
package de.ivu.elect.business.wahl.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahl.entity.WahlParameter;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractWahlParameterEdit {

  @Inject
  protected WahlParameterDAO dao;

  @Inject
  protected WahlParameterExtendedDAO extendedDao;

  public void delete(WahlParameter entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(WahlParameter entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(WahlParameter entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected WahlParameter getAttachedEntity(WahlParameter entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected WahlParameter getAttachedAndRefreshedEntity(WahlParameter entity) {
    return dao.refresh(entity);
  }
}
